/**
 * @author MoXun
 */
import { Component, ViewEncapsulation, Input, Output, EventEmitter } from '@angular/core';
import { FadeAnimation } from '../core/animation/fade-animations';
var NzAlertComponent = (function () {
    function NzAlertComponent() {
        this._display = true;
        this.nzType = 'info';
        this.nzBanner = false;
        this.nzCloseable = false;
        this.nzShowIcon = false;
        this.nzOnClose = new EventEmitter();
    }
    Object.defineProperty(NzAlertComponent.prototype, "_classMap", {
        get: function () {
            var antAlert = 'ant-alert';
            return _a = {},
                _a["" + antAlert] = true,
                _a[antAlert + "-" + this.nzType] = true,
                _a[antAlert + "-no-icon"] = !this.nzShowIcon,
                _a[antAlert + "-banner"] = this.nzBanner,
                _a[antAlert + "-with-description"] = !!this.nzDescription,
                _a;
            var _a;
        },
        enumerable: true,
        configurable: true
    });
    NzAlertComponent.prototype.closeAlert = function () {
        this._display = false;
        this.nzOnClose.emit(true);
    };
    return NzAlertComponent;
}());
export { NzAlertComponent };
NzAlertComponent.decorators = [
    { type: Component, args: [{
                selector: 'nz-alert',
                encapsulation: ViewEncapsulation.None,
                animations: [FadeAnimation],
                template: "\n    <div [ngClass]=\"_classMap\" *ngIf=\"_display\" [@fadeAnimation]>\n      <i\n        class=\"ant-alert-icon anticon\"\n        [class.anticon-cross-circle-o]=\"nzType==='error'\"\n        [class.anticon-check-circle-o]=\"nzType==='success'\"\n        [class.anticon-info-circle-o]=\"nzType==='info'\"\n        [class.anticon-exclamation-circle-o]=\"nzType==='warning'\"\n        *ngIf=\"nzShowIcon&&nzDescription\"></i>\n      <i\n        class=\"ant-alert-icon anticon\"\n        [class.anticon-cross-circle]=\"nzType==='error'\"\n        [class.anticon-check-circle]=\"nzType==='success'\"\n        [class.anticon-info-circle]=\"nzType==='info'\"\n        [class.anticon-exclamation-circle]=\"nzType==='warning'\"\n        *ngIf=\"nzShowIcon&&!nzDescription\"></i>\n      <ng-template [ngIf]=\"nzMessage\">\n        <span class=\"ant-alert-message\">{{nzMessage}}</span>\n      </ng-template>\n      <ng-template [ngIf]=\"!nzMessage\">\n        <ng-content select=\"[alert-body]\"></ng-content>\n      </ng-template>\n      <ng-template [ngIf]=\"nzDescription\">\n        <span class=\"ant-alert-description\">{{nzDescription}}</span>\n      </ng-template>\n      <ng-template [ngIf]=\"!nzDescription\">\n        <ng-content select=\"alert-description\"></ng-content>\n      </ng-template>\n      <ng-template [ngIf]=\"nzCloseable || nzCloseText\">\n        <a *ngIf=\"nzCloseable\" (click)=\"closeAlert($event)\" class=\"ant-alert-close-icon\">\n          <i class=\"anticon anticon-cross\"></i>\n        </a>\n        <a *ngIf=\"nzCloseText\" class=\"ant-alert-close-icon\" (click)=\"closeAlert()\">{{nzCloseText}}</a>\n      </ng-template>\n    </div>\n  ",
                styles: [
                    "/* stylelint-disable at-rule-empty-line-before,at-rule-name-space-after,at-rule-no-unknown */\n/* stylelint-disable declaration-bang-space-before */\n/* stylelint-disable declaration-bang-space-before */\n.ant-alert {\n  position: relative;\n  padding: 8px 48px 8px 38px;\n  border-radius: 4px;\n  color: rgba(0, 0, 0, 0.65);\n  font-size: 12px;\n  line-height: 1.5;\n}\n.ant-alert.ant-alert-no-icon {\n  padding: 8px 48px 8px 16px;\n}\n.ant-alert-icon {\n  font-size: 14px;\n  top: 10px;\n  left: 16px;\n  position: absolute;\n}\n.ant-alert-description {\n  font-size: 12px;\n  line-height: 21px;\n  display: none;\n}\n.ant-alert-success {\n  border: 1px solid #cfefdf;\n  background-color: #ebf8f2;\n}\n.ant-alert-success .ant-alert-icon {\n  color: #00a854;\n}\n.ant-alert-info {\n  border: 1px solid #d2eafb;\n  background-color: #ecf6fd;\n}\n.ant-alert-info .ant-alert-icon {\n  color: #108ee9;\n}\n.ant-alert-warning {\n  border: 1px solid #fff3cf;\n  background-color: #fffaeb;\n}\n.ant-alert-warning .ant-alert-icon {\n  color: #ffbf00;\n}\n.ant-alert-error {\n  border: 1px solid #fcdbd9;\n  background-color: #fef0ef;\n}\n.ant-alert-error .ant-alert-icon {\n  color: #f04134;\n}\n.ant-alert-close-icon {\n  font-size: 12px;\n  position: absolute;\n  right: 16px;\n  top: 10px;\n  height: 12px;\n  line-height: 12px;\n  overflow: hidden;\n  cursor: pointer;\n}\n.ant-alert-close-icon .anticon-cross {\n  color: rgba(0, 0, 0, 0.43);\n  transition: color .3s ease;\n}\n.ant-alert-close-icon .anticon-cross:hover {\n  color: #404040;\n}\n.ant-alert-close-text {\n  position: absolute;\n  right: 16px;\n}\n.ant-alert-with-description {\n  padding: 16px 16px 16px 60px;\n  position: relative;\n  border-radius: 4px;\n  color: rgba(0, 0, 0, 0.65);\n  line-height: 1.5;\n}\n.ant-alert-with-description.ant-alert-no-icon {\n  padding: 16px;\n}\n.ant-alert-with-description .ant-alert-icon {\n  position: absolute;\n  top: 16px;\n  left: 20px;\n  font-size: 24px;\n}\n.ant-alert-with-description .ant-alert-close-icon {\n  position: absolute;\n  top: 16px;\n  right: 16px;\n  cursor: pointer;\n  font-size: 12px;\n}\n.ant-alert-with-description .ant-alert-message {\n  font-size: 14px;\n  color: rgba(0, 0, 0, 0.85);\n  display: block;\n  margin-bottom: 4px;\n}\n.ant-alert-with-description .ant-alert-description {\n  display: block;\n}\n.ant-alert.ant-alert-close {\n  height: 0 !important;\n  margin: 0;\n  padding-top: 0;\n  padding-bottom: 0;\n  transition: all 0.3s cubic-bezier(0.78, 0.14, 0.15, 0.86);\n  transform-origin: 50% 0;\n}\n.ant-alert-slide-up-leave {\n  animation: antAlertSlideUpOut 0.3s cubic-bezier(0.78, 0.14, 0.15, 0.86);\n  animation-fill-mode: both;\n}\n.ant-alert-banner {\n  border-radius: 0;\n  border: 0;\n  margin-bottom: 0;\n}\n@keyframes antAlertSlideUpIn {\n  0% {\n    opacity: 0;\n    transform-origin: 0% 0%;\n    transform: scaleY(0);\n  }\n  100% {\n    opacity: 1;\n    transform-origin: 0% 0%;\n    transform: scaleY(1);\n  }\n}\n@keyframes antAlertSlideUpOut {\n  0% {\n    opacity: 1;\n    transform-origin: 0% 0%;\n    transform: scaleY(1);\n  }\n  100% {\n    opacity: 0;\n    transform-origin: 0% 0%;\n    transform: scaleY(0);\n  }\n}\n",
                    "nz-alert {\n  display: block;\n}\n"
                ]
            },] },
];
/** @nocollapse */
NzAlertComponent.ctorParameters = function () { return []; };
NzAlertComponent.propDecorators = {
    'nzType': [{ type: Input },],
    'nzBanner': [{ type: Input },],
    'nzCloseable': [{ type: Input },],
    'nzDescription': [{ type: Input },],
    'nzShowIcon': [{ type: Input },],
    'nzCloseText': [{ type: Input },],
    'nzMessage': [{ type: Input },],
    'nzOnClose': [{ type: Output },],
};
