import { Component, Input, HostBinding, ContentChild, ViewEncapsulation } from '@angular/core';
var NzCardComponent = (function () {
    function NzCardComponent() {
        this.nzBordered = true;
        this.nzLoading = false;
        this.nzNoHovering = false;
        this._nzCard = true;
    }
    return NzCardComponent;
}());
export { NzCardComponent };
NzCardComponent.decorators = [
    { type: Component, args: [{
                selector: 'nz-card',
                encapsulation: ViewEncapsulation.None,
                template: "\n    <div class=\"ant-card-head\" *ngIf=\"title\">\n      <h3 class=\"ant-card-head-title\">\n        <ng-template\n          [ngTemplateOutlet]=\"title\">\n        </ng-template>\n      </h3>\n    </div>\n    <div class=\"ant-card-extra\" *ngIf=\"extra\">\n      <ng-template\n        [ngTemplateOutlet]=\"extra\">\n      </ng-template>\n    </div>\n    <div class=\"ant-card-body\">\n      <ng-template\n        *ngIf=\"!nzLoading\"\n        [ngTemplateOutlet]=\"body\">\n      </ng-template>\n      <div *ngIf=\"nzLoading\">\n        <p class=\"ant-card-loading-block\" style=\"width: 94%;\"></p>\n        <p>\n          <span class=\"ant-card-loading-block\" style=\"width: 28%;\"></span><span class=\"ant-card-loading-block\" style=\"width: 62%;\"></span>\n        </p>\n        <p>\n          <span class=\"ant-card-loading-block\" style=\"width: 22%;\"></span><span class=\"ant-card-loading-block\" style=\"width: 66%;\"></span>\n        </p>\n        <p>\n          <span class=\"ant-card-loading-block\" style=\"width: 56%;\"></span><span class=\"ant-card-loading-block\" style=\"width: 39%;\"></span>\n        </p>\n        <p>\n          <span class=\"ant-card-loading-block\" style=\"width: 21%;\"></span><span class=\"ant-card-loading-block\" style=\"width: 15%;\"></span><span class=\"ant-card-loading-block\" style=\"width: 40%;\"></span>\n        </p>\n      </div>\n    </div>\n  ",
                styles: [
                    "/* stylelint-disable at-rule-empty-line-before,at-rule-name-space-after,at-rule-no-unknown */\n/* stylelint-disable declaration-bang-space-before */\n/* stylelint-disable declaration-bang-space-before */\n.ant-card {\n  background: #fff;\n  border-radius: 2px;\n  font-size: 12px;\n  position: relative;\n  transition: all .3s;\n}\n.ant-card:not(.ant-card-no-hovering):hover {\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n  border-color: transparent;\n}\n.ant-card-bordered {\n  border: 1px solid #e9e9e9;\n}\n.ant-card-head {\n  height: 48px;\n  line-height: 48px;\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n  padding: 0 24px;\n  border-radius: 2px 2px 0 0;\n}\n.ant-card-head-title {\n  font-size: 14px;\n  display: inline-block;\n  text-overflow: ellipsis;\n  width: 100%;\n  overflow: hidden;\n  white-space: nowrap;\n  color: rgba(0, 0, 0, 0.85);\n  font-weight: 500;\n}\n.ant-card-extra {\n  position: absolute;\n  right: 24px;\n  top: 14px;\n}\n.ant-card-body {\n  padding: 24px;\n  zoom: 1;\n}\n.ant-card-body:before,\n.ant-card-body:after {\n  content: \" \";\n  display: table;\n}\n.ant-card-body:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-card-loading .ant-card-body {\n  user-select: none;\n  padding: 0;\n}\n.ant-card-loading-content {\n  padding: 24px;\n}\n.ant-card-loading-block {\n  display: inline-block;\n  margin: 5px 1% 0;\n  height: 14px;\n  border-radius: 2px;\n  background: linear-gradient(90deg, rgba(207, 216, 220, 0.2), rgba(207, 216, 220, 0.4), rgba(207, 216, 220, 0.2));\n  animation: card-loading 1.4s ease infinite;\n  background-size: 600% 600%;\n}\n.ant-card-contain-grid .ant-card-body {\n  margin: -0.5px;\n  padding: 0;\n}\n.ant-card-grid {\n  border-radius: 0;\n  border: 0;\n  box-shadow: 0 0 0 0.5px #e9e9e9, 0 0 0 0.5px #e9e9e9 inset;\n  width: 33.33%;\n  float: left;\n  padding: 24px;\n  transition: all .3s;\n}\n.ant-card-grid:hover {\n  position: relative;\n  z-index: 1;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-card-wider-padding .ant-card-head {\n  padding: 0 32px;\n}\n.ant-card-wider-padding .ant-card-body {\n  padding: 24px 32px;\n}\n.ant-card-wider-padding .ant-card-extra {\n  right: 32px;\n}\n.ant-card-padding-transition .ant-card-head,\n.ant-card-padding-transition .ant-card-body {\n  transition: padding .3s;\n}\n.ant-card-padding-transition .ant-card-extra {\n  transition: right .3s;\n}\n@keyframes card-loading {\n  0%,\n  100% {\n    background-position: 0 50%;\n  }\n  50% {\n    background-position: 100% 50%;\n  }\n}\n",
                    "nz-card {\n  display: block;\n  position: relative;\n}\n"
                ]
            },] },
];
/** @nocollapse */
NzCardComponent.ctorParameters = function () { return []; };
NzCardComponent.propDecorators = {
    'nzBordered': [{ type: Input }, { type: HostBinding, args: ['class.ant-card-bordered',] },],
    'nzLoading': [{ type: Input },],
    'nzNoHovering': [{ type: Input }, { type: HostBinding, args: ['class.ant-card-no-hovering',] },],
    'title': [{ type: ContentChild, args: ['title',] },],
    'extra': [{ type: ContentChild, args: ['extra',] },],
    'body': [{ type: ContentChild, args: ['body',] },],
    '_nzCard': [{ type: HostBinding, args: ['class.ant-card',] },],
};
