import { OnInit, OnChanges, SimpleChanges, OnDestroy, EventEmitter } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { Observable } from 'rxjs/Observable';
import { Subscription } from 'rxjs/Subscription';
import { NzSliderService } from './nz-slider.service';
import { Marks, MarksArray } from './nz-slider-marks.component';
export declare type SliderValue = number[] | number;
export declare class SliderHandle {
    offset: number;
    value: number;
    active: boolean;
}
export declare class NzSliderComponent implements ControlValueAccessor, OnInit, OnChanges, OnDestroy {
    private utils;
    nzDebugId: number | string;
    nzDisabled: boolean;
    nzStep: number;
    nzMarks: Marks;
    nzDots: boolean;
    nzMin: number;
    nzMax: number;
    nzIncluded: boolean;
    nzDefaultValue: SliderValue;
    nzTipFormatter: Function;
    nzOnAfterChange: EventEmitter<number | number[]>;
    nzVertical: boolean | string;
    nzRange: boolean | string;
    _range: boolean;
    _vertical: boolean;
    value: SliderValue;
    private slider;
    sliderDOM: any;
    cacheSliderStart: number;
    cacheSliderLength: number;
    prefixCls: string;
    classMap: Object;
    activeValueIndex: number;
    track: {
        offset: any;
        length: any;
    };
    handles: SliderHandle[];
    marksArray: MarksArray;
    bounds: {
        lower: any;
        upper: any;
    };
    onValueChange: Function;
    isDragging: boolean;
    dragstart$: Observable<number>;
    dragmove$: Observable<number>;
    dragend$: Observable<number>;
    dragstart_: Subscription;
    dragmove_: Subscription;
    dragend_: Subscription;
    setValue(val: SliderValue, isWriteValue?: boolean): void;
    getValue(cloneAndSort?: boolean): SliderValue;
    getValueToOffset(value?: SliderValue): number | number[];
    writeValue(val: SliderValue): void;
    registerOnChange(fn: Function): void;
    registerOnTouched(fn: any): void;
    constructor(utils: NzSliderService);
    ngOnInit(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngOnDestroy(): void;
    setClassMap(): void;
    setActiveValueIndex(pointerValue: number): void;
    setActiveValue(pointerValue: number): void;
    updateTrackAndHandles(): void;
    toMarksArray(marks: any): any[];
    onDragStart(value: number): void;
    onDragMove(value: number): void;
    onDragEnd(): void;
    createDrag(): void;
    subscribeDrag(periods?: string[]): void;
    unsubscribeDrag(periods?: string[]): void;
    toggleDragMoving(movable: boolean): void;
    toggleDragDisabled(disabled: boolean): void;
    findClosestValue(position: number): number;
    valueToOffset(value: any): number;
    getSliderStartPosition(): number;
    getSliderLength(): any;
    cacheSliderProperty(remove?: boolean): void;
    formatValue(value: SliderValue): SliderValue;
    checkValidValue(value: any): boolean;
    isValueEqual(value: SliderValue, val: SliderValue): boolean;
    log(...messages: Array<any>): void;
    private _showHandleTooltip(handleIndex?);
    private _hideAllHandleTooltip();
    private _generateHandles(amount);
}
