import { Component, Input, ViewEncapsulation } from '@angular/core';
import { NzStepConnectService } from './nz-step-connect.service';
var NzStepsComponent = (function () {
    function NzStepsComponent(nzStepConnectService) {
        this.nzStepConnectService = nzStepConnectService;
        this._progressDot = false;
        this._direction = 'horizontal';
    }
    Object.defineProperty(NzStepsComponent.prototype, "nzDirection", {
        get: function () {
            return this._direction;
        },
        set: function (value) {
            this._direction = value;
            this.nzStepConnectService.direction = value;
            this.nzStepConnectService.directionEvent.next(value);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NzStepsComponent.prototype, "nzProgressDot", {
        get: function () {
            return this._progressDot;
        },
        set: function (value) {
            if (value === '') {
                this._progressDot = true;
            }
            else {
                this._progressDot = value;
            }
            this.nzStepConnectService.processDot = true;
            this.nzStepConnectService.processDotEvent.next(true);
            this.setDirectionClass();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NzStepsComponent.prototype, "nzStatus", {
        set: function (status) {
            this._status = status;
            this.nzStepConnectService.errorIndex = this._status;
            this.nzStepConnectService.errorIndexObject.next(this._status);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NzStepsComponent.prototype, "nzCurrent", {
        get: function () {
            return this._current;
        },
        set: function (current) {
            this._current = current;
            this.nzStepConnectService.current = current;
            this.nzStepConnectService.currentEvent.next(current);
        },
        enumerable: true,
        configurable: true
    });
    NzStepsComponent.prototype.setDirectionClass = function () {
        this._stepsClassMap = (_a = {},
            _a["ant-steps-" + this.nzDirection] = true,
            _a["ant-steps-label-" + this.nzDirection] = true,
            _a["ant-steps-dot"] = this.nzProgressDot,
            _a['ant-steps-small'] = this.nzSize === 'small',
            _a);
        var _a;
    };
    NzStepsComponent.prototype.ngOnInit = function () {
        this.setDirectionClass();
        if (this._status) {
            this.nzStepConnectService.errorIndex = this._status;
            this.nzStepConnectService.errorIndexObject.next(this._status);
        }
    };
    NzStepsComponent.prototype.ngOnDestroy = function () {
        this.nzStepConnectService.itemIndex = 0;
    };
    return NzStepsComponent;
}());
export { NzStepsComponent };
NzStepsComponent.decorators = [
    { type: Component, args: [{
                selector: 'nz-steps',
                encapsulation: ViewEncapsulation.None,
                providers: [NzStepConnectService],
                template: "\n    <div class=\"ant-steps\" [ngClass]=\"_stepsClassMap\">\n      <ng-content></ng-content>\n    </div>\n  ",
                styles: [
                    "/* stylelint-disable at-rule-empty-line-before,at-rule-name-space-after,at-rule-no-unknown */\n/* stylelint-disable declaration-bang-space-before */\n/* stylelint-disable declaration-bang-space-before */\n.ant-steps {\n  font-size: 0;\n  line-height: 1.5;\n}\n.ant-steps .ant-steps-item {\n  position: relative;\n  display: inline-block;\n  vertical-align: top;\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-head-inner {\n  border-color: rgba(0, 0, 0, 0.25);\n  background-color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-head-inner > .ant-steps-icon {\n  color: rgba(0, 0, 0, 0.25);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: rgba(0, 0, 0, 0.25);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-title {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-description {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-wait .ant-steps-tail > i {\n  background-color: #e9e9e9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-head-inner {\n  border-color: #108ee9;\n  background-color: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-head-inner > .ant-steps-icon {\n  color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-title {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-description {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-steps .ant-steps-item.ant-steps-status-process .ant-steps-tail > i {\n  background-color: #e9e9e9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-head-inner {\n  border-color: #108ee9;\n  background-color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-head-inner > .ant-steps-icon {\n  color: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: #108ee9;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-tail > i:after {\n  width: 100%;\n  background: #108ee9;\n  transition: all .6s;\n  opacity: 1;\n  box-shadow: 0 0 0 0 #108ee9;\n  animation: tailEffect .4s;\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-title {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-finish .ant-steps-description {\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-head-inner {\n  border-color: #f04134;\n  background-color: #fff;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-head-inner > .ant-steps-icon {\n  color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-head-inner > .ant-steps-icon .ant-steps-icon-dot {\n  background: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-title {\n  color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-description {\n  color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-status-error .ant-steps-tail > i {\n  background-color: #e9e9e9;\n}\n.ant-steps .ant-steps-item.ant-steps-next-error .ant-steps-tail > i,\n.ant-steps .ant-steps-item.ant-steps-next-error .ant-steps-tail > i:after {\n  background-color: #f04134;\n}\n.ant-steps .ant-steps-item.ant-steps-custom .ant-steps-head-inner {\n  background: none;\n  border: 0;\n  width: auto;\n  height: auto;\n}\n.ant-steps .ant-steps-item.ant-steps-custom .ant-steps-head-inner > .ant-steps-icon {\n  font-size: 26px;\n  width: 26px;\n  height: 26px;\n}\n.ant-steps .ant-steps-item.ant-steps-custom.ant-steps-status-process .ant-steps-head-inner > .ant-steps-icon {\n  color: #108ee9;\n}\n.ant-steps .ant-steps-head,\n.ant-steps .ant-steps-main {\n  position: relative;\n  display: inline-block;\n  vertical-align: top;\n}\n.ant-steps .ant-steps-head {\n  background: #fff;\n}\n.ant-steps .ant-steps-head-inner {\n  display: block;\n  border: 1px solid rgba(0, 0, 0, 0.25);\n  width: 26px;\n  height: 26px;\n  line-height: 23px;\n  text-align: center;\n  border-radius: 26px;\n  font-size: 14px;\n  margin-right: 8px;\n  transition: background-color 0.3s ease, border-color 0.3s ease;\n}\n.ant-steps .ant-steps-head-inner > .ant-steps-icon {\n  line-height: 1;\n  color: #108ee9;\n  position: relative;\n}\n.ant-steps .ant-steps-head-inner > .ant-steps-icon.anticon {\n  font-size: 12px;\n}\n.ant-steps .ant-steps-head-inner > .ant-steps-icon.anticon-cross,\n.ant-steps .ant-steps-head-inner > .ant-steps-icon.anticon-check {\n  font-weight: bold;\n}\n.ant-steps .ant-steps-title {\n  font-size: 14px;\n  line-height: 26px;\n  color: rgba(0, 0, 0, 0.65);\n  font-weight: bold;\n  background-color: #fff;\n  display: inline-block;\n  padding-right: 10px;\n}\n.ant-steps .ant-steps-title > a:first-child:last-child {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-steps .ant-steps-item:last-child .ant-steps-title {\n  padding-right: 0;\n  width: 100%;\n}\n.ant-steps .ant-steps-item:last-child .ant-steps-tail {\n  display: none;\n}\n.ant-steps .ant-steps-description {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps .ant-steps-tail {\n  position: absolute;\n  left: 0;\n  width: 100%;\n  top: 13px;\n  padding: 0 10px;\n}\n.ant-steps .ant-steps-tail > i {\n  display: inline-block;\n  vertical-align: top;\n  background: #e9e9e9;\n  height: 1px;\n  border-radius: 1px;\n  width: 100%;\n  position: relative;\n}\n.ant-steps .ant-steps-tail > i:after {\n  position: absolute;\n  content: '';\n  top: 0;\n  width: 0;\n  background: #e9e9e9;\n  height: 100%;\n  opacity: 0;\n}\n.ant-steps.ant-steps-small .ant-steps-head-inner {\n  border: 1px solid rgba(0, 0, 0, 0.25);\n  width: 18px;\n  height: 18px;\n  line-height: 15px;\n  text-align: center;\n  border-radius: 18px;\n  font-size: 12px;\n  margin-right: 10px;\n}\n.ant-steps.ant-steps-small .ant-steps-head-inner > .ant-steps-icon.anticon {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 9px 9;\n  transform: scale(0.75) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  top: 0;\n}\n:root .ant-steps.ant-steps-small .ant-steps-head-inner > .ant-steps-icon.anticon {\n  filter: none;\n}\n:root .ant-steps.ant-steps-small .ant-steps-head-inner > .ant-steps-icon.anticon {\n  font-size: 12px;\n}\n.ant-steps.ant-steps-small .ant-steps-main {\n  margin-top: 0;\n}\n.ant-steps.ant-steps-small .ant-steps-title {\n  font-size: 12px;\n  line-height: 18px;\n  color: rgba(0, 0, 0, 0.65);\n  font-weight: bold;\n}\n.ant-steps.ant-steps-small .ant-steps-description {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-steps.ant-steps-small .ant-steps-tail {\n  top: 8px;\n  padding: 0 8px;\n}\n.ant-steps.ant-steps-small .ant-steps-tail > i {\n  height: 1px;\n  border-radius: 1px;\n  width: 100%;\n}\n.ant-steps.ant-steps-small .ant-steps-custom .ant-steps-head-inner > .ant-steps-icon {\n  font-size: 18px;\n  width: 18px;\n  height: 18px;\n}\n.ant-steps-vertical > .ant-steps-item {\n  display: block;\n}\n.ant-steps-vertical > .ant-steps-item > .ant-steps-tail {\n  position: absolute;\n  left: 13px;\n  top: 0;\n  height: 100%;\n  width: 1px;\n  padding: 30px 0 4px;\n}\n.ant-steps-vertical > .ant-steps-item > .ant-steps-tail > i {\n  height: 100%;\n  width: 1px;\n}\n.ant-steps-vertical > .ant-steps-item > .ant-steps-tail > i:after {\n  height: 0;\n  width: 100%;\n}\n.ant-steps-vertical .ant-steps-status-finish .ant-steps-tail > i:after {\n  height: 100%;\n}\n.ant-steps-vertical .ant-steps-head {\n  float: left;\n}\n.ant-steps-vertical .ant-steps-head-inner {\n  margin-right: 16px;\n}\n.ant-steps-vertical .ant-steps-main {\n  min-height: 47px;\n  overflow: hidden;\n  display: block;\n}\n.ant-steps-vertical .ant-steps-main .ant-steps-title {\n  line-height: 26px;\n}\n.ant-steps-vertical .ant-steps-main .ant-steps-description {\n  padding-bottom: 12px;\n}\n.ant-steps-vertical.ant-steps-small .ant-steps-tail {\n  position: absolute;\n  left: 9px;\n  top: 0;\n  padding: 22px 0 4px;\n}\n.ant-steps-vertical.ant-steps-small .ant-steps-tail > i {\n  height: 100%;\n}\n.ant-steps-vertical.ant-steps-small .ant-steps-title {\n  line-height: 18px;\n}\n.ant-steps-horizontal.ant-steps-hidden {\n  visibility: hidden;\n}\n.ant-steps-horizontal .ant-steps-description {\n  max-width: 120px;\n}\n.ant-steps-horizontal .ant-steps-item:not(:first-child) .ant-steps-head {\n  padding-left: 10px;\n  margin-left: -10px;\n}\n.ant-steps-dot .ant-steps-item .ant-steps-step {\n  display: inline-block;\n  text-align: center;\n  width: 120px;\n}\n.ant-steps-dot .ant-steps-item:not(:first-child) .ant-steps-head {\n  margin-left: 0;\n  padding-left: 0;\n}\n.ant-steps-dot .ant-steps-tail {\n  margin: 0 0 0 60px;\n  padding: 0;\n  width: 100%;\n  top: 1px;\n}\n.ant-steps-dot .ant-steps-tail > i {\n  height: 3px;\n}\n.ant-steps-dot .ant-steps-head {\n  display: inline-block;\n  padding-right: 0;\n}\n.ant-steps-dot .ant-steps-head-inner {\n  margin: 0 auto;\n  width: 5px;\n  height: 5px;\n  line-height: 5px;\n  border: 0;\n}\n.ant-steps-dot .ant-steps-head-inner .ant-steps-icon-dot {\n  float: left;\n  width: 100%;\n  height: 100%;\n  border-radius: 2.5px;\n  position: relative;\n}\n.ant-steps-dot .ant-steps-head-inner .ant-steps-icon-dot:after {\n  content: '';\n  background: rgba(255, 255, 255, 0.001);\n  width: 40px;\n  height: 24px;\n  position: absolute;\n  top: -8px;\n  left: -16px;\n}\n.ant-steps-dot .ant-steps-head-inner .ant-steps-icon-dot:hover {\n  transform: scale(1.3);\n}\n.ant-steps-dot .ant-steps-main {\n  display: block;\n  margin-top: 10px;\n}\n.ant-steps-dot .ant-steps-main .ant-steps-title {\n  padding-right: 0;\n  background-color: transparent;\n}\n.ant-steps-dot .ant-steps-status-process .ant-steps-head {\n  top: -1px;\n}\n.ant-steps-dot .ant-steps-status-process .ant-steps-head-inner {\n  width: 7px;\n  height: 7px;\n  line-height: 7px;\n}\n.ant-steps-dot .ant-steps-status-process .ant-steps-head-inner .ant-steps-icon-dot {\n  border-radius: 3.5px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-tail {\n  left: 2px;\n  height: 100%;\n  padding: 0;\n  top: 15px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-tail > i {\n  height: 100%;\n  width: 3px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-head {\n  top: 12px;\n  left: 1px;\n}\n.ant-steps-dot.ant-steps-vertical .ant-steps-status-process .ant-steps-head {\n  left: 0;\n}\n@keyframes tailEffect {\n  to {\n    box-shadow: 0 0 3px 3px transparent;\n  }\n}\n"
                ]
            },] },
];
/** @nocollapse */
NzStepsComponent.ctorParameters = function () { return [
    { type: NzStepConnectService, },
]; };
NzStepsComponent.propDecorators = {
    'nzDirection': [{ type: Input },],
    'nzSize': [{ type: Input },],
    'nzProgressDot': [{ type: Input },],
    'nzStatus': [{ type: Input },],
    'nzCurrent': [{ type: Input },],
};
