import { Component, ViewEncapsulation, Input, ElementRef, EventEmitter, Output } from '@angular/core';
var NzTableComponent = (function () {
    function NzTableComponent(_elementRef) {
        this._elementRef = _elementRef;
        /** public data for ngFor tr */
        this.data = [];
        this._current = 1;
        this._pageSize = 10;
        this._dataSet = [];
        this._isInit = false;
        this._isAjax = false;
        this.nzPageSizeChange = new EventEmitter();
        this.nzPageIndexChange = new EventEmitter();
        this.nzDataChange = new EventEmitter();
        this.nzPageIndexChangeClick = new EventEmitter();
        this.nzBordered = false;
        this.nzCustomNoResult = false;
        this.nzIsPagination = true;
        this.nzLoading = false;
        this.nzShowSizeChanger = false;
        this.nzShowQuickJumper = false;
        this.nzShowTotal = false;
        this.nzShowFooter = false;
        this.nzShowTitle = false;
        this._el = this._elementRef.nativeElement;
    }
    Object.defineProperty(NzTableComponent.prototype, "nzAjaxData", {
        /** async data */
        get: function () {
            return this.data;
        },
        set: function (data) {
            this._isAjax = true;
            this.data = data;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NzTableComponent.prototype, "nzDataSource", {
        /** sync data */
        get: function () {
            return this._dataSet;
        },
        set: function (value) {
            this._dataSet = value;
            this.nzTotal = this._dataSet.length;
            this._generateData(true);
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NzTableComponent.prototype, "nzPageIndex", {
        get: function () {
            return this._current;
        },
        set: function (value) {
            if (this._current === value) {
                return;
            }
            this._current = value;
            this._generateData();
            this.nzPageIndexChange.emit(this.nzPageIndex);
        },
        enumerable: true,
        configurable: true
    });
    ;
    ;
    NzTableComponent.prototype.pageChangeClick = function (value) {
        this.nzPageIndexChangeClick.emit(value);
    };
    Object.defineProperty(NzTableComponent.prototype, "nzPageSize", {
        get: function () {
            return this._pageSize;
        },
        set: function (value) {
            if (this._pageSize === value) {
                return;
            }
            this._pageSize = value;
            this._generateData();
            if (this._isInit) {
                this.nzPageSizeChange.emit(value);
            }
        },
        enumerable: true,
        configurable: true
    });
    ;
    ;
    Object.defineProperty(NzTableComponent.prototype, "nzTotal", {
        get: function () {
            return this._total;
        },
        set: function (value) {
            if (this._total === value) {
                return;
            }
            this._total = value;
        },
        enumerable: true,
        configurable: true
    });
    ;
    NzTableComponent.prototype._generateData = function (forceRefresh) {
        if (forceRefresh === void 0) { forceRefresh = false; }
        if (!this._isAjax) {
            if (this.nzIsPagination) {
                if (forceRefresh) {
                    this.nzPageIndex = 1;
                }
                this.data = this._dataSet.slice((this.nzPageIndex - 1) * this.nzPageSize, this.nzPageIndex * this.nzPageSize);
            }
            else {
                this.data = this._dataSet;
            }
            this.nzDataChange.emit(this.data);
        }
    };
    NzTableComponent.prototype.ngAfterViewInit = function () {
        this._isInit = true;
    };
    return NzTableComponent;
}());
export { NzTableComponent };
NzTableComponent.decorators = [
    { type: Component, args: [{
                selector: 'nz-table',
                encapsulation: ViewEncapsulation.None,
                template: "\n    <div\n      class=\"ant-table-wrapper\"\n      [class.ant-table-empty]=\"data.length==0\">\n      <nz-spin [nzSpinning]=\"nzLoading\">\n        <div>\n          <div\n            class=\"ant-table\"\n            [class.ant-table-bordered]=\"nzBordered\"\n            [class.ant-table-large]=\"(nzSize!=='middle')&&(nzSize!=='small')\"\n            [class.ant-table-middle]=\"nzSize=='middle'\"\n            [class.ant-table-small]=\"nzSize=='small'\">\n            <div class=\"ant-table-title\" *ngIf=\"nzShowTitle\">\n              <ng-content select=\"[nz-table-title]\"></ng-content>\n            </div>\n            <div class=\"ant-table-content\">\n              <div class=\"ant-table-body\">\n                <table>\n                  <ng-content></ng-content>\n                </table>\n              </div>\n              <div class=\"ant-table-placeholder\" *ngIf=\"data.length==0 && !nzCustomNoResult\">\n                <span>\u6CA1\u6709\u6570\u636E</span>\n              </div>\n              <div class=\"ant-table-placeholder\" *ngIf=\"data.length==0 && nzCustomNoResult\">\n                <ng-content select=\"[noResult]\"></ng-content>\n              </div>\n              <div class=\"ant-table-footer\" *ngIf=\"nzShowFooter\">\n                <ng-content select=\"[nz-table-footer]\"></ng-content>\n              </div>\n            </div>\n          </div>\n        </div>\n      </nz-spin>\n      <nz-pagination\n        *ngIf=\"nzIsPagination&&data.length\"\n        class=\"ant-table-pagination\"\n        [nzShowSizeChanger]=\"nzShowSizeChanger\"\n        [nzShowQuickJumper]=\"nzShowQuickJumper\"\n        [nzShowTotal]=\"nzShowTotal\"\n        [nzSize]=\"(nzSize=='middle'||nzSize=='small')?'small':''\"\n        [(nzPageSize)]=\"nzPageSize\"\n        [nzTotal]=\"nzTotal\"\n        [(nzPageIndex)]=\"nzPageIndex\"\n        (nzPageIndexClickChange)=\"pageChangeClick($event)\">\n      </nz-pagination>\n    </div>\n  ",
                styles: [
                    "/* stylelint-disable at-rule-empty-line-before,at-rule-name-space-after,at-rule-no-unknown */\n/* stylelint-disable declaration-bang-space-before */\n/* stylelint-disable declaration-bang-space-before */\n.ant-table-wrapper {\n  zoom: 1;\n}\n.ant-table-wrapper:before,\n.ant-table-wrapper:after {\n  content: \" \";\n  display: table;\n}\n.ant-table-wrapper:after {\n  clear: both;\n  visibility: hidden;\n  font-size: 0;\n  height: 0;\n}\n.ant-table {\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.65);\n  overflow: hidden;\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  /* fix firefox scrollbar bug */\n}\n.ant-table-body {\n  transition: opacity 0.3s ease;\n}\n.ant-table table {\n  width: 100%;\n  border-collapse: separate;\n  border-spacing: 0;\n  text-align: left;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-thead > tr > th {\n  background: #f7f7f7;\n  font-weight: 500;\n  transition: background .3s ease;\n  text-align: left;\n  color: rgba(0, 0, 0, 0.85);\n}\n.ant-table-thead > tr > th[colspan] {\n  text-align: center;\n}\n.ant-table-thead > tr > th .anticon-filter,\n.ant-table-thead > tr > th .ant-table-filter-icon {\n  position: relative;\n  margin-left: 4px;\n  font-size: 12px;\n  cursor: pointer;\n  color: #aaa;\n  transition: all .3s;\n  width: 14px;\n}\n.ant-table-thead > tr > th .anticon-filter:hover,\n.ant-table-thead > tr > th .ant-table-filter-icon:hover {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-thead > tr > th .ant-table-filter-icon:after {\n  content: '';\n  position: absolute;\n  width: 14px;\n  height: 50px;\n  left: 0;\n  top: -19px;\n}\n.ant-table-thead > tr > th .ant-table-filter-selected.anticon-filter {\n  color: #108ee9;\n}\n.ant-table-tbody > tr > td {\n  border-bottom: 1px solid #e9e9e9;\n  transition: all .3s;\n}\n.ant-table-thead > tr,\n.ant-table-tbody > tr {\n  transition: all .3s;\n}\n.ant-table-thead > tr.ant-table-row-hover > td,\n.ant-table-tbody > tr.ant-table-row-hover > td,\n.ant-table-thead > tr:hover > td,\n.ant-table-tbody > tr:hover > td {\n  background: #ecf6fd;\n}\n.ant-table-thead > tr:hover {\n  background: none;\n}\n.ant-table-footer {\n  padding: 16px 8px;\n  background: #f7f7f7;\n  border-radius: 0 0 4px 4px;\n  position: relative;\n}\n.ant-table-footer:before {\n  content: '';\n  height: 1px;\n  background: #f7f7f7;\n  position: absolute;\n  top: -1px;\n  width: 100%;\n  left: 0;\n}\n.ant-table.ant-table-bordered .ant-table-footer {\n  border: 1px solid #e9e9e9;\n}\n.ant-table-title {\n  padding: 16px 0;\n  position: relative;\n  top: 1px;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table.ant-table-bordered .ant-table-title {\n  border: 1px solid #e9e9e9;\n  padding-left: 8px;\n  padding-right: 8px;\n}\n.ant-table-title + .ant-table-content {\n  position: relative;\n  border-radius: 4px 4px 0 0;\n  overflow: hidden;\n}\n.ant-table-bordered .ant-table-title + .ant-table-content,\n.ant-table-bordered .ant-table-title + .ant-table-content table {\n  border-radius: 0;\n}\n.ant-table-without-column-header .ant-table-title + .ant-table-content,\n.ant-table-without-column-header table {\n  border-radius: 0;\n}\n.ant-table-tbody > tr.ant-table-row-selected {\n  background: #fafafa;\n}\n.ant-table-thead > tr > th.ant-table-column-sort {\n  background: #eee;\n}\n.ant-table-thead > tr > th,\n.ant-table-tbody > tr > td {\n  padding: 16px 8px;\n  word-break: break-all;\n}\n.ant-table-thead > tr > th.ant-table-selection-column-custom {\n  padding-left: 16px;\n  padding-right: 0;\n}\n.ant-table-thead > tr > th.ant-table-selection-column,\n.ant-table-tbody > tr > td.ant-table-selection-column {\n  text-align: center;\n  min-width: 62px;\n  width: 62px;\n}\n.ant-table-expand-icon-th,\n.ant-table-row-expand-icon-cell {\n  text-align: center;\n  min-width: 50px;\n  width: 50px;\n}\n.ant-table-header {\n  background: #f7f7f7;\n  overflow: hidden;\n}\n.ant-table-header table {\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-loading {\n  position: relative;\n}\n.ant-table-loading .ant-table-body {\n  background: #fff;\n  opacity: 0.5;\n}\n.ant-table-loading .ant-table-spin-holder {\n  height: 20px;\n  line-height: 20px;\n  left: 50%;\n  top: 50%;\n  margin-left: -30px;\n  position: absolute;\n}\n.ant-table-loading .ant-table-with-pagination {\n  margin-top: -20px;\n}\n.ant-table-loading .ant-table-without-pagination {\n  margin-top: 10px;\n}\n.ant-table-middle .ant-table-thead > tr > th:not(.ant-table-selection-column),\n.ant-table-middle .ant-table-tbody > tr > td {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-title,\n.ant-table-middle .ant-table-footer {\n  padding: 10px 8px;\n}\n.ant-table-middle .ant-table-column-sorter-up:after {\n  top: -13px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-middle .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-middle .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 38px;\n  top: -13px;\n}\n.ant-table-small {\n  border: 1px solid #e9e9e9;\n  border-radius: 4px;\n}\n.ant-table-small .ant-table-header > table,\n.ant-table-small .ant-table-body > table {\n  border: 0;\n  padding: 0 8px;\n}\n.ant-table-small .ant-table-thead > tr > th {\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-tbody > tr > td {\n  padding: 6px 8px;\n}\n.ant-table-small .ant-table-title,\n.ant-table-small .ant-table-footer,\n.ant-table-small .ant-table-thead > tr > th:not(.ant-table-selection-column) {\n  padding: 10px 8px;\n}\n.ant-table-small .ant-table-title {\n  border-bottom: 1px solid #e9e9e9;\n  top: 0;\n}\n.ant-table-small .ant-table-header {\n  background: #fff;\n}\n.ant-table-small .ant-table-header table {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-small .ant-table-placeholder,\n.ant-table-small .ant-table-row:last-child td {\n  border-bottom: 0;\n}\n.ant-table-small .ant-table-column-sorter-up:after {\n  top: -14px;\n  height: 13px;\n}\n.ant-table-small .ant-table-column-sorter-down:after {\n  bottom: -11px;\n  height: 13px;\n}\n.ant-table-small .ant-table-thead > tr > th .anticon-filter:after,\n.ant-table-small .ant-table-thead > tr > th .ant-table-filter-icon:after {\n  height: 39px;\n  top: -14px;\n}\n.ant-table-column-sorter {\n  position: relative;\n  margin-left: 4px;\n  display: inline-block;\n  width: 14px;\n  height: 14px;\n  vertical-align: middle;\n  text-align: center;\n}\n.ant-table-column-sorter-up,\n.ant-table-column-sorter-down {\n  line-height: 4px;\n  display: block;\n  width: 14px;\n  cursor: pointer;\n}\n.ant-table-column-sorter-up:hover .anticon,\n.ant-table-column-sorter-down:hover .anticon {\n  color: rgba(0, 0, 0, 0.65);\n}\n.ant-table-column-sorter-up.on .anticon-caret-up,\n.ant-table-column-sorter-down.on .anticon-caret-up,\n.ant-table-column-sorter-up.on .anticon-caret-down,\n.ant-table-column-sorter-down.on .anticon-caret-down {\n  color: #108ee9;\n}\n.ant-table-column-sorter-up:after,\n.ant-table-column-sorter-down:after {\n  position: absolute;\n  content: '';\n  height: 20px;\n  width: 14px;\n  left: 0;\n}\n.ant-table-column-sorter-up:after {\n  top: -19px;\n}\n.ant-table-column-sorter-down:after {\n  bottom: -17px;\n}\n.ant-table-column-sorter .anticon-caret-up,\n.ant-table-column-sorter .anticon-caret-down {\n  display: inline-block;\n  font-size: 12px;\n  font-size: 8px 9;\n  transform: scale(0.66666667) rotate(0deg);\n  /* IE6-IE8 */\n  -ms-filter: \"progid:DXImageTransform.Microsoft.Matrix(sizingMethod='auto expand', M11=1, M12=0, M21=0, M22=1)\";\n  zoom: 1;\n  line-height: 6px;\n  height: 6px;\n  color: #aaa;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  filter: none;\n}\n:root .ant-table-column-sorter .anticon-caret-up,\n:root .ant-table-column-sorter .anticon-caret-down {\n  font-size: 12px;\n}\n.ant-table-column-sorter .anticon-caret-up:before,\n.ant-table-column-sorter .anticon-caret-down:before {\n  -moz-transform-origin: 53% 50%;\n  /* fix firefox position */\n}\n.ant-table-bordered .ant-table-header > table,\n.ant-table-bordered .ant-table-body > table,\n.ant-table-bordered .ant-table-fixed-left table,\n.ant-table-bordered .ant-table-fixed-right table {\n  border: 1px solid #e9e9e9;\n  border-right: 0;\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-empty .ant-table-placeholder {\n  border-left: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-header > table {\n  border-bottom: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body > table {\n  border-top: 0;\n  border-top-left-radius: 0;\n  border-top-right-radius: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-body-inner > table {\n  border-top: 0;\n}\n.ant-table-bordered.ant-table-fixed-header .ant-table-placeholder {\n  border: 0;\n}\n.ant-table-bordered .ant-table-thead > tr > th {\n  border-bottom: 1px solid #e9e9e9;\n}\n.ant-table-bordered .ant-table-thead > tr > th,\n.ant-table-bordered .ant-table-tbody > tr > td {\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small {\n  border-right: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-header > table,\n.ant-table-bordered.ant-table-small .ant-table-body > table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-left table,\n.ant-table-bordered.ant-table-small .ant-table-fixed-right table {\n  border: 0;\n  padding: 0;\n}\n.ant-table-bordered.ant-table-small .ant-table-title {\n  border: 0;\n  border-bottom: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer {\n  border: 0;\n  border-top: 1px solid #e9e9e9;\n  border-right: 1px solid #e9e9e9;\n}\n.ant-table-bordered.ant-table-small .ant-table-footer:before {\n  display: none;\n}\n.ant-table-bordered.ant-table-small .ant-table-placeholder {\n  border-left: 0;\n  border-bottom: 0;\n}\n.ant-table-placeholder {\n  position: relative;\n  padding: 16px 8px;\n  background: #fff;\n  border-bottom: 1px solid #e9e9e9;\n  text-align: center;\n  font-size: 12px;\n  color: rgba(0, 0, 0, 0.43);\n}\n.ant-table-placeholder .anticon {\n  margin-right: 4px;\n}\n.ant-table-pagination {\n  margin: 16px 0;\n  float: right;\n}\n.ant-table-filter-dropdown {\n  min-width: 96px;\n  margin-left: -8px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu {\n  border: 0;\n  box-shadow: none;\n  border-radius: 4px 4px 0 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-without-submenu {\n  max-height: 400px;\n  overflow-x: hidden;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item > label + span {\n  padding: 0;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-sub {\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-filter-dropdown .ant-dropdown-menu .ant-dropdown-submenu-contain-selected .ant-dropdown-menu-submenu-title:after {\n  color: #108ee9;\n  font-weight: bold;\n  text-shadow: 0 0 2px #d2eafb;\n}\n.ant-table-filter-dropdown .ant-dropdown-menu-item {\n  overflow: hidden;\n}\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-item:last-child,\n.ant-table-filter-dropdown > .ant-dropdown-menu > .ant-dropdown-menu-submenu:last-child .ant-dropdown-menu-submenu-title {\n  border-radius: 0;\n}\n.ant-table-filter-dropdown-btns {\n  overflow: hidden;\n  padding: 7px 8px;\n  border-top: 1px solid #e9e9e9;\n}\n.ant-table-filter-dropdown-link {\n  color: #108ee9;\n}\n.ant-table-filter-dropdown-link:hover {\n  color: #49a9ee;\n}\n.ant-table-filter-dropdown-link:active {\n  color: #0e77ca;\n}\n.ant-table-filter-dropdown-link.confirm {\n  float: left;\n}\n.ant-table-filter-dropdown-link.clear {\n  float: right;\n}\n.ant-table-selection-select-all-custom {\n  margin-right: 4px !important;\n}\n.ant-table-selection .anticon-down {\n  color: #aaa;\n  transition: all .3s;\n}\n.ant-table-selection-menu {\n  min-width: 96px;\n  margin-top: 5px;\n  margin-left: -30px;\n  background: #fff;\n  border-radius: 4px;\n  box-shadow: 0 1px 6px rgba(0, 0, 0, 0.2);\n}\n.ant-table-selection-menu .ant-action-down {\n  color: #aaa;\n}\n.ant-table-selection-down {\n  cursor: pointer;\n  padding: 0;\n  display: inline-block;\n  line-height: 1;\n}\n.ant-table-selection-down:hover .anticon-down {\n  color: #666;\n}\n.ant-table-row-expand-icon {\n  cursor: pointer;\n  display: inline-block;\n  width: 17px;\n  height: 17px;\n  text-align: center;\n  line-height: 14px;\n  border: 1px solid #e9e9e9;\n  user-select: none;\n  background: #fff;\n}\n.ant-table-row-expanded:after {\n  content: '-';\n}\n.ant-table-row-collapsed:after {\n  content: '+';\n}\n.ant-table-row-spaced {\n  visibility: hidden;\n}\n.ant-table-row-spaced:after {\n  content: '.';\n}\n.ant-table-row[class*=\"ant-table-row-level-0\"] .ant-table-selection-column > span {\n  display: inline-block;\n}\ntr.ant-table-expanded-row,\ntr.ant-table-expanded-row:hover {\n  background: #fbfbfb;\n}\n.ant-table .ant-table-row-indent + .ant-table-row-expand-icon {\n  margin-right: 8px;\n}\n.ant-table-scroll {\n  overflow: auto;\n  overflow-x: hidden;\n}\n.ant-table-scroll table {\n  width: auto;\n  min-width: 100%;\n}\n.ant-table-body-inner {\n  height: 100%;\n}\n.ant-table-fixed-header > .ant-table-content > .ant-table-scroll > .ant-table-body {\n  position: relative;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-body-inner {\n  overflow: scroll;\n}\n.ant-table-fixed-header .ant-table-scroll .ant-table-header {\n  overflow: scroll;\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-header.ant-table-empty .ant-table-scroll .ant-table-body {\n  padding-bottom: 20px;\n  margin-bottom: -20px;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-right {\n  position: absolute;\n  top: 0;\n  overflow: hidden;\n  transition: box-shadow 0.3s ease;\n  border-radius: 0;\n}\n.ant-table-fixed-left table,\n.ant-table-fixed-right table {\n  width: auto;\n  background: #fff;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-outer .ant-table-fixed,\n.ant-table-fixed-header .ant-table-fixed-right .ant-table-body-outer .ant-table-fixed {\n  border-radius: 0;\n}\n.ant-table-fixed-left {\n  left: 0;\n  box-shadow: 6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-left .ant-table-header {\n  overflow-y: hidden;\n}\n.ant-table-fixed-left .ant-table-body-inner {\n  margin-right: -20px;\n  padding-right: 20px;\n}\n.ant-table-fixed-header .ant-table-fixed-left .ant-table-body-inner {\n  padding-right: 0;\n}\n.ant-table-fixed-left,\n.ant-table-fixed-left table {\n  border-radius: 4px 0 0 0;\n}\n.ant-table-fixed-right {\n  right: 0;\n  box-shadow: -6px 0 6px -4px rgba(0, 0, 0, 0.2);\n}\n.ant-table-fixed-right,\n.ant-table-fixed-right table {\n  border-radius: 0 4px 0 0;\n}\n.ant-table-fixed-right .ant-table-expanded-row {\n  color: transparent;\n  pointer-events: none;\n}\n.ant-table.ant-table-scroll-position-left .ant-table-fixed-left {\n  box-shadow: none;\n}\n.ant-table.ant-table-scroll-position-right .ant-table-fixed-right {\n  box-shadow: none;\n}\n",
                    ".nz-resize-container {\n  position: relative;\n}\n.nz-resize-y {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 10px;\n  height: 102%;\n  background: transparent;\n  cursor: col-resize;\n}\n.nz-resizing th,\n.nz-resizing td {\n  user-select: none;\n}\n"
                ]
            },] },
];
/** @nocollapse */
NzTableComponent.ctorParameters = function () { return [
    { type: ElementRef, },
]; };
NzTableComponent.propDecorators = {
    'nzPageSizeChange': [{ type: Output },],
    'nzPageIndexChange': [{ type: Output },],
    'nzDataChange': [{ type: Output },],
    'nzPageIndexChangeClick': [{ type: Output },],
    'nzBordered': [{ type: Input },],
    'nzSize': [{ type: Input },],
    'nzCustomNoResult': [{ type: Input },],
    'nzIsPagination': [{ type: Input },],
    'nzLoading': [{ type: Input },],
    'nzShowSizeChanger': [{ type: Input },],
    'nzShowQuickJumper': [{ type: Input },],
    'nzShowTotal': [{ type: Input },],
    'nzShowFooter': [{ type: Input },],
    'nzShowTitle': [{ type: Input },],
    'nzAjaxData': [{ type: Input },],
    'nzDataSource': [{ type: Input },],
    'nzPageIndex': [{ type: Input },],
    'nzPageSize': [{ type: Input },],
    'nzTotal': [{ type: Input },],
};
